// пример работы с лентой
#define LED_PIN 6       // пин ленты
#define NUMLEDS 64       // кол-во светодиодов

#define MICROLED_ALLOW_INTERRUPTS	// запрещает запрет прерываний на время отправки данных
#define ORDER_GRB       // порядок цветов ORDER_GRB / ORDER_RGB / ORDER_BRG
#define MAX_DATA_SPEED  // разогнанный протокол связи (на 40% быстрее). Работает на ws2812/13. На 2811 не работает

#define COLOR_DEBTH 2   // цветовая глубина: 1, 2, 3 (в байтах)
// на меньшем цветовом разрешении скетч будет занимать в разы меньше места,
// но уменьшится и количество оттенков и уровней яркости!

// ВНИМАНИЕ! define настройки (ORDER_GRB и COLOR_DEBTH) делаются до подключения библиотеки!
#include <microLED.h>

LEDdata leds[NUMLEDS];  // буфер ленты типа LEDdata (размер зависит от COLOR_DEBTH)
microLED strip(leds, NUMLEDS, LED_PIN);  // объект лента

void setup() {
  strip.setBrightness(30);    // яркость (0-255)
  // яркость применяется при выводе .show() !

  strip.setVoltage(4500);     // установить напряжение питания в мв, по умолч. 5000 (для расчёта тока)
  strip.setMaxCurrent(700);   // установить максимальный ток (автокоррекция яркости). 0 - выключено
  // при .show() яркость будет скорректирована, чтобы ток не превышал установленный
}

void loop() {

}
